Updating the NTP Registries
RFC 9748
Rich Salz
Akamai Technologies
rsalz@akamai.com
February 2025
INT
ntp
NTP
extensions
registries
IANA
The Network Time Protocol (NTP) and Network Time Security (NTS) documents define a number of registries, collectively called the NTP registries.
Some registries are correct, but some include incorrect assignments and some don’t follow common practice. For the sake of completeness, this document reviews all NTP and NTS registries, and corrects the registries where necessary.
This document updates RFCs 5905, 5906, 7821, 7822, and 8573.
Introduction
The Network Time Protocol (NTP) and Network Time Security (NTS) documents define a number of registries, collectively called the NTP registries. The NTP registries can all be found at https://www.iana.org/assignments/ntp-parameters and the NTS registries can all be found at https://www.iana.org/assignments/nts.
Some registries are correct, but some include incorrect assignments and some don’t follow common practice. For the sake of completeness, this document reviews all NTP and NTS registries, and corrects the registries where necessary.
The bulk of this document can be divided into two parts:
- a summary of the relevant registries, including syntax requirements, registration procedures, and the defining documents.
- a revised format and entries for each registry being modified.
Existing Registries
This section describes the registries and the rules for them. It is intended to be a short summary of the syntax and registration requirements for each registry. The semantics and protocol processing rules for each registry -- that is, how an implementation acts when sending or receiving any of the fields -- are not described here.
Reference ID and Kiss-o'-Death Registries
[RFC5905] defines two registries: "NTP Reference Identifier Codes" in Section 7.3 and the "NTP Kiss-o'-Death Codes" in Section 7.4. Reference identifiers and kiss codes can be up to four ASCII characters, padded on the right with all-bits-zero if necessary. Entries that start with 0x58, the ASCII letter uppercase X, are reserved for Private or Experimental Use. Both registries are First Come First Served. The registries were created per Section 16 of [RFC5905].
Extension Field Types
Section 7.5 of [RFC5905] defines the on-the-wire format of extension fields but does not create a registry for them.
Section 13 of [RFC5906] mentions the "NTP Extension Field Types" registry, and defines it indirectly by defining 30 extensions (10 each for request, response, and error response). It does not provide a formal definition of the columns in the registry. Section 10 of [RFC5906] splits the Field Type into four subfields, only for use within the Autokey extensions.
[RFC7821] adds a new entry, Checksum Complement, to the "NTP Extension Field Types" registry.
[RFC7822] clarifies the processing rules for Extension Field Types, particularly around the interaction with the Message Authentication Code (MAC) field. NTPv4 packets may contain a MAC that appears where one would expect the next extension field header.
[RFC8573] changes the cryptography used in the MAC field.
[RFC8915] adds four new entries to the "NTP Extension Field Types" registry.
The following problems exist with the current registry:
- Many of the entries in the "NTP Extension Field Types" registry have swapped some of the nibbles; for example, 0x0302 was listed for Cookie Message Request instead of 0x0203. The errors are due to documentation errors with the original implementation of Autokey. This document marks the erroneous values as reserved, in case there is an implementation using the registered values instead of what the original implementation used. Applications that used those values would have realized that they did not interoperate with the dominant (if not only) implementation at the time. Marking the values as reserved ensures that any such applications continue to work as is.
- Some values were mistakenly reused.
Network Time Security Registries
[RFC8915] defines the NTS protocol. The related registries are listed here for completeness, but there are no changes specified in this document.
In [RFC8915]:
Sections 7.1 through 7.5 (inclusive) added entries to existing registries.
Section 7.6 created the "Network Time Security Key Establishment Record Types" registry that partitions the range into three different registration policies: IETF Review, Specification Required, and Private or Experimental Use.
Section 7.7 created the "Network Time Security Next Protocols" registry that similarly partitions the range.
Section 7.8 created the "Network Time Security Error Codes" and "Network Time Security Warning Codes" registries. Both registries are partitioned the same way.
NTP Registry Updates
The following general guidelines apply to the NTP registries:
- A partition of the "NTP Extension Field Types" registry is reserved for Private or Experimental Use.
- In the "NTP Reference Identifier Codes" and "NTP Kiss-o'-Death Codes" registries, entries with ASCII fields are now limited to uppercase letters or digits. Fields starting with 0x58, the uppercase letter "X", are reserved for Private or Experimental Use.
- The policy for each registry is now Specification Required, as defined in [RFC8126], Section 4.6.
Designated Experts
The IESG is requested to choose three designated experts (DEs), with approvals from two being required to implement a change. Guidance for the experts is given below.
The DEs should be familiar with [RFC8126], particularly Section 5. As that reference suggests, the DE should ascertain the existence of a suitable specification and verify that it is publicly available. The DE is also expected to check the clarity of purpose and use of the requested code points.
In addition, the DE is expected to be familiar with this document, specifically the history documented here.
IANA Considerations
Each entry described in the subsections below is intended to completely replace the existing entry with the same name.
NTP Reference Identifier Codes
The registration procedure has been changed to Specification Required and this document has been added as a reference.
The Note has been changed to read as follows:
Codes beginning with the character "X" are reserved for experimentation and development. IANA cannot assign them.
The columns are defined as follows:
ID (required):
a four-byte value padded on the right with all-bits-zero. Each byte other than padding must be ASCII uppercase letters or digits.
Clock source (required):
a brief text description of the ID.
Reference (required):
the publication defining the ID.
The existing entries are left unchanged.
NTP Kiss-o'-Death Codes
The registration procedure is changed to Specification Required and this document has been added as a reference.
The Note has been changed to read as follows:
Codes beginning with the character "X" are reserved for experimentation and development. IANA cannot assign them.
The columns are defined as follows:
ID (required):
a four-byte value padded on the right with all-bits-zero. Each byte other than padding must be ASCII uppercase letters or digits.
Meaning source (required):
a brief text description of the ID.
Reference (required):
the publication defining the ID.
The existing entries are left unchanged.
NTP Extension Field Types
The registration procedure has been changed to Specification Required and [RFC5906] and this document have been added as references.
The following two Notes have been added:
Field Types in the range 0xF000 through 0xFFFF, inclusive, are reserved for experimentation and development. IANA cannot assign them. Both NTS Cookie and Autokey Message Request have the same Field Type; in practice this is not a problem as the field semantics will be determined by other parts of the message.
The "Reserved for historic reasons" is for differences between the original documentation and implementation of Autokey and marks the erroneous values as reserved, in case there is an implementation that used the registered values instead of what the original implementation used.
The columns are defined as follows:
Field Type (required):
a two-byte value in hexadecimal.
Meaning (required):
a brief text description of the field type.
Reference (required):
the publication defining the field type.
IANA has updated the registry as shown in Table 1.
Field Type | Meaning | Reference
0x0000 | Crypto-NAK; authentication failure | [RFC5905]
0x0002 | Reserved for historic reasons | RFC 9748
0x0102 | Reserved for historic reasons | RFC 9748
0x0104 | Unique Identifier | [RFC8915], Section 5.3
0x0200 | No-Operation Request | [RFC5906]
0x0201 | Association Message Request | [RFC5906]
0x0202 | Certificate Message Request | [RFC5906]
0x0203 | Cookie Message Request | [RFC5906]
0x0204 | Autokey Message Request | [RFC5906]
0x0204 | NTS Cookie | [RFC8915], Section 5.4
0x0205 | Leapseconds Message Request | [RFC5906]
0x0206 | Sign Message Request | [RFC5906]
0x0207 | IFF Identity Message Request | [RFC5906]
0x0208 | GQ Identity Message Request | [RFC5906]
0x0209 | MV Identity Message Request | [RFC5906]
0x0302 | Reserved for historic reasons | RFC 9748
0x0304 | NTS Cookie Placeholder | [RFC8915], Section 5.5
0x0402 | Reserved for historic reasons | RFC 9748
0x0404 | NTS Authenticator and Encrypted Extension Fields | [RFC8915], Section 5.6
0x0502 | Reserved for historic reasons | RFC 9748
0x0602 | Reserved for historic reasons | RFC 9748
0x0702 | Reserved for historic reasons | RFC 9748
0x0802 | Reserved for historic reasons | RFC 9748
0x0902 | Reserved for historic reasons | RFC 9748
0x2005 | UDP Checksum Complement | [RFC7821]
0x8002 | Reserved for historic reasons | RFC 9748
0x8102 | Reserved for historic reasons | RFC 9748
0x8200 | No-Operation Response | [RFC5906]
0x8201 | Association Message Response | [RFC5906]
0x8202 | Certificate Message Response | [RFC5906]
0x8203 | Cookie Message Response | [RFC5906]
0x8204 | Autokey Message Response | [RFC5906]
0x8205 | Leapseconds Message Response | [RFC5906]
0x8206 | Sign Message Response | [RFC5906]
0x8207 | IFF Identity Message Response | [RFC5906]
0x8208 | GQ Identity Message Response | [RFC5906]
0x8209 | MV Identity Message Response | [RFC5906]
0x8302 | Reserved for historic reasons | RFC 9748
0x8402 | Reserved for historic reasons | RFC 9748
0x8502 | Reserved for historic reasons | RFC 9748
0x8602 | Reserved for historic reasons | RFC 9748
0x8702 | Reserved for historic reasons | RFC 9748
0x8802 | Reserved for historic reasons | RFC 9748
0x8902 | Reserved for historic reasons | RFC 9748
0xC002 | Reserved for historic reasons | RFC 9748
0xC102 | Reserved for historic reasons | RFC 9748
0xC200 | No-Operation Error Response | [RFC5906]
0xC201 | Association Message Error Response | [RFC5906]
0xC202 | Certificate Message Error Response | [RFC5906]
0xC203 | Cookie Message Error Response | [RFC5906]
0xC204 | Autokey Message Error Response | [RFC5906]
0xC205 | Leapseconds Message Error Response | [RFC5906]
0xC206 | Sign Message Error Response | [RFC5906]
0xC207 | IFF Identity Message Error Response | [RFC5906]
0xC208 | GQ Identity Message Error Response | [RFC5906]
0xC209 | MV Identity Message Error Response | [RFC5906]
0xC302 | Reserved for historic reasons | RFC 9748
0xC402 | Reserved for historic reasons | RFC 9748
0xC502 | Reserved for historic reasons | RFC 9748
0xC602 | Reserved for historic reasons | RFC 9748
0xC702 | Reserved for historic reasons | RFC 9748
0xC802 | Reserved for historic reasons | RFC 9748
0xC902 | Reserved for historic reasons | RFC 9748
0xF000-0xFFFF | Reserved for Experimental Use | RFC 9748
Security Considerations
This document adds no new security considerations, as they are defined in the document that defines the extension. See the References column of the appropriate IANA registry.
Normative References
[RFC5905]
[RFC5906]
[RFC7821]
[RFC7822]
[RFC8573]
[RFC8915]
[RFC8126]
Acknowledgements
The members of the NTP Working Group helped a great deal. Notable contributors include:
- Miroslav Lichvar, Red Hat
- Daniel Franke, formerly at Akamai Technologies
- Danny Mayer, Network Time Foundation
- Michelle Cotton, formerly at IANA
- Tamme Dittrich, Tweede Golf